
#ifndef MAXPOINTS
#define MAXPOINTS 100000
#endif

#ifndef NPSTAGE
#define NPSTAGE 200
#endif

#ifndef PI
#define PI 3.141593
#endif

typedef char* filename;

enum bands { vband=0, bcorr=2, lum=3, uband,bband,rband,iband,jband,hband,kband,lband,
	     mband,Ogband,Orband,Oiband,nband};

enum kernels { none = -1 ,rectangle=0, triangle, normal, epanechnikov}; 


double Dexp (double );
double Absolut (double );


double
Dexp (double inp)
{
double ret;
double buf=1e+38;
if (inp>38) return buf;
ret = pow (10.0,inp);
return ret;
};

double 
Absolut ( double inp)
{
if (inp<0) return -1.0*inp;
return inp;
};

double LI ( double x_c, double x1, double x2, double y1, double y2)
{
 double y_c;
 if (x_c==x1) return y1;
 if (x_c==x2) return y2;
 if  (x2==x1) 
  {
  if (y2==y1) return y2;
   else 
    {
    return (y1+y2)/2.0;
    };
  }; 
 y_c = (y2 - y1)/(x2 - x1) * (x_c - x1) + y1;
 return y_c;
};

double 
MF (double lage, double mass, double alf)
{
double mass_f,nn;
nn=100;
mass_f=nn*pow(mass,alf);
return mass_f;
};

double 
TF (double mass, double log_t0, double log_t, double beta)
{
double time_f;
time_f=pow (Dexp(log_t)/Dexp(log_t0),beta);
return time_f;
};


double Kernel (kernels k_in, double x)
{
double k_add=0;
 if (Absolut(x)>1) return 0; 
 switch (k_in) 
  {
  case rectangle : k_add=0.5; break;
  case triangle  : k_add=1-Absolut(x); break; 
  case normal    : k_add=exp(-x*x/2)/sqrt(2*PI); break;
  case epanechnikov : k_add=3*(1-x*x)/4.0; break; 
  case none: k_add=1.0; break;
  };
return k_add;
};
